/*	
 *	clipfp16.h
 *
 *	16bit_`
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2009 Naoyuki Sawa
 *
 *	* Mon Jul 27 18:33:57 JST 2009 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __CLIP_FP16_H__
#define __CLIP_FP16_H__

/****************************************************************************
 *	
 ****************************************************************************/

/*	===================
 *	16bit_`
 *	===================
 *
 *	seeeeemm mmmmmmmm
 *	||||||++-++++++++-  10bit + Öق 1bit
 *	|+++++------------ w  5bit   oCAX 15
 *	+----------------- 
 *
 *	\\ȍŏ̐Βl  0.00006103515625 0ɂȂ܂
 *	\\ȍő̐Βl  131008           傫ƃI[o[t[G[ɂȂ܂
 *
 *	DirectXFP16Ɠrbg\łB
 *	DirectXFP16ƁA{Cufp16ŁAقȂ_́Aȉ̂ƂłB
 *
 *	EDirectXFP16́Aw0AA0łȂƂɁA񐳋KƌȂ܂B
 *	  {Cufp16́Aw0̏ꍇ́A̒lɂ炸A+0ƌȂ܂B
 *
 *	EDirectXFP16́Aw31̏ꍇɁANaNA܂́AƌȂ܂B
 *	  {Cufp16́Aw31̏ꍇAw1`32̏ꍇƓƂ܂B
 *
 *	{Cufp16́At@Ceʐߖ̖ړIō쐬̂łB
 *	fp16𒼐ډZ֐́ApӂĂ܂B
 *	ŹAfloat`ōsȂĂB
 *
 *	<>
 *		fp16 data[1000];
 *		fread(data, sizeof(fp16), 1000, fp);     // t@Cfp16`Ń[h
 *		for(i = 0; i < 1000; i++) {
 *			float tmp = fp16_read(&data[i]); // fp16` -> float`ɕϊ
 *			tmp = sqrtf(tmp);                // float`ŉZ
 *			fp16_write(&data[i], tmp);       // float` -> fp1`ɕϊĊi[
 *		}
 */
typedef struct _fp16 {
	unsigned short m : 10;	/* mantissa */
	unsigned short e :  5;	/* exponent */
	unsigned short s :  1;	/* sign */
} fp16;

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

/* fp16f[^ǂݏoAfloatlɕϊ܂B
 * [in]
 *	p		ǂݏofp16f[^̃AhXB
 * [out]
 *	߂l		ϊfloatlB
 */
float fp16_read(const fp16* p);

/* floatlϊAfp16f[^ƂĊi[܂B
 * [in]
 *	p		i[fp16f[^̃AhXB
 *	f		ϊfloatlB
 */
void fp16_write(fp16* p, float f);

#endif /*__CLIP_FP16_H__*/

