/*	
 *	cliplot.c
 *
 *	I
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2014 Naoyuki Sawa
 *
 *	* Tue May 29 00:54:45 JST 2012 Naoyuki Sawa
 *	- 1st [XB
 *	* Sat Aug 03 00:18:29 JST 2013 Naoyuki Sawa
 *	- I\̃f[^\ύXAI̐ǉ܂B
 *	  LOT_draw_table()ɕsȒICfNXw肵AG[~悤ɂ܂B
 *	- tool/MkLotTbl.awk ύXAVf[^\ɉI\o͂悤ɂ܂B
 *	  AÂf[^\̒I\gp鎖͂܂B
 *	* Tue Jan 14 23:30:11 JST 2014 Naoyuki Sawa
 *	- I\̃f[^\ύXAIidǉ܂B
 *	  LOT_draw_table()̎dlύXAICfNXłȂidƃXLbv񐔂Ŏw肷悤ɂ܂B
 *	- tool/MkLotTbl.awk ύXAVf[^\ɉI\o͂悤ɂ܂B
 *	  AÂf[^\̒I\gp鎖͂܂B
 *	* Fri Jan 31 01:01:32 JST 2014 Naoyuki Sawa
 *	- LOT_get_column_weight()LOT_get_table_weight()ǉ܂B
 *	* Fri Feb 28 01:16:14 JST 2014 Naoyuki Sawa
 *	- LOT_get_table_size()LOT_get_table_column_id()ǉ܂B
 *	* Sat Aug 23 11:56:18 JST 2014 Naoyuki Sawa
 *	- LOT_draw_table_gl(),LOT_draw_table_ga(),LOT_draw_table_gv()ǉ܂B
 *	- LOT_get_table_weight_gl(),LOT_get_table_weight_ga(),LOT_get_table_weight_gv()ǉ܂B
 *	- LOT_get_table_size_g()ǉ܂B
 *	* Mon Aug 25 20:01:41 JST 2014 Naoyuki Sawa
 *	- uI\v̌`ύX܂BO[vwb_̊TO͖Ȃ܂B
 *	  ́uuI\vɑ΂钊IvƁuuO[vwb_tI\vɑ΂钊Iv폜āA
 *	  VuuI\vɑ΂钊Iv`܂B
 */
#include "clip.h"

/****************************************************************************
 *	uIvɑ΂钊I
 ****************************************************************************/

#ifndef PIECE
int LOT_draw_column(const unsigned short* column, int column_size, int rndval) {
	int hitval, weight;
	for(;;) {
		/* ȈI[ɓBA-1Ԃ܂B */
		if(--column_size < 0) { return -1; }
		/*  Il   擾܂B */
		hitval = *column++;
		/* (dݒl-1)擾܂B */
		weight = *column++;
		/* ldݒlA0ɂȂ瓖IłB */
		if((rndval -= (weight + 1)) < 0) { return hitval; }
	}
}
#else /*PIECE*/
int LOT_draw_column(const unsigned short* column, int column_size, int rndval);
asm("
		.code
		.align		1
		.global		LOT_draw_column
LOT_draw_column:
		;// %r12 := column
		;// %r13 := column_size
		;// %r14 := rndval
LOT_draw_column_LOOP:
		sub		%r13, 1			;// %r13 := column_size--
		jrlt		LOT_draw_column_MISS	;// if(column_size < 0) return -1
		;//
		ld.uh		%r10, [%r12]+		;// %r10 := hitval = *column++
		ld.uh		%r11, [%r12]+		;// %r11 := weight = *column++
;//{{
;//		add		%r11, 1			;// %r11 :=           (weight + 1)
;//		sub		%r14, %r11		;// %r14 := rndval -= (weight + 1)
;//		jrge		LOT_draw_column_LOOP	;// if(rndval <  0) return hitval
;//
		sub		%r14, %r11		;// %r14 := rndval -= (weight    )
		jrgt.d		LOT_draw_column_LOOP	;// if(rndval <= 0) return hitval
		sub		%r14, 1			;// %r14 := rndval -= (         1)	*delay*
;//}}
		ret					;// return  hitval
LOT_draw_column_MISS:
		ret.d					;// return  -1
		ld.w		%r10, -1		;// %r10 := -1				*delay*
");
#endif/*PIECE*/

/*--------------------------------------------------------------------------*/

#ifndef PIECE
int LOT_get_column_weight(const unsigned short* column, int column_size, int hitval_sel) {
	int hitval, weight;
	for(;;) {
		/* ȈI[ɓBA0Ԃ܂B */
		if(--column_size < 0) { return 0; }
		/*  Il   擾܂B */
		hitval = *column++;
		/* (dݒl-1)擾܂B */
		weight = *column++;
		/* IlvAdݒl(1`65536)Ԃ܂B */
		if(hitval == hitval_sel) { return (weight + 1); }
	}
}
#else /*PIECE*/
int LOT_get_column_weight(const unsigned short* column, int column_size, int hitval_sel);
asm("
		.code
		.align		1
		.global		LOT_get_column_weight
LOT_get_column_weight:
		;// %r12 := column
		;// %r13 := column_size
		;// %r14 := hitval_sel
LOT_get_column_weight_LOOP:
		sub		%r13, 1				;// %r13 := column_size--
		jrlt		LOT_get_column_weight_MISS	;// if(column_size < 0) return 0
		;//
		ld.uh		%r11, [%r12]+			;// %r11 := hitval = *column++
		ld.uh		%r10, [%r12]+			;// %r10 := weight = *column++
		cmp		%r11, %r14			;// if(hitval == hitval_sel)
		jrne		LOT_get_column_weight_LOOP
		ret.d						;//   return  (weight + 1)
		add		%r10, 1				;//   %r10 := (weight + 1)	*delay*
LOT_get_column_weight_MISS:
		ret.d						;// return  0
		ld.w		%r10, 0				;// %r10 := 0			*delay*
");
#endif/*PIECE*/

//{{2014/08/25폜:uI\v`ύX̂߂ɁAÂR[h폜܂BÂR[h2014/08/24܂Ŗ薳삵Ă̂ŁAQlpƂăRg܂܎cĂ܂B
//	
//	/****************************************************************************
//	 *	uI\vɑ΂钊I
//	 ****************************************************************************/
//	
//	#ifndef PIECE
//	static int LOT_seek_and_call(const unsigned short* table, int id_skip, int param, int (*fn)(const unsigned short* column, int column_size, int param)) {
//		int id, skip, table_size, column_id, column_size;
//		/* IidƃXLbv񐔂𕪗܂B */
//		id   = (unsigned short)(id_skip >>  0); /* 0`65535 */
//		skip = (unsigned short)(id_skip >> 16); /* 0`65535 */
//		/* I\̗񐔂擾܂B */
//		table_size = *table++;
//		for(;;) {
//			/* I\̍ŏI𒴂ĂAG[~܂B */
//			if(--table_size < 0) { DIE(); } /* f[^G[: I\̒ɁAw肳ꂽidI񂪁A(skip+1)ȏoȂB */
//			/* Iid擾܂B */
//			column_id   = *table++;
//			/* I̗vf擾܂B */
//			column_size = *table++;
//			/* w肳ꂽidI񂪌AXLbv񐔂炵0ɂȂA֐s܂B */
//			if((column_id == id) && (--skip < 0)) { return (*fn)(table, column_size, param); }
//			/* IXLbv܂B */
//			table += column_size * 2/*{hitval,weight}*/;
//		}
//	}
//	#else /*PIECE*/
//	/*static*/ int LOT_seek_and_call(const unsigned short* table, int id_skip, int param, int (*fn)(const unsigned short* column, int column_size, int param));
//	asm("
//			.code
//			.align		1
//	LOT_seek_and_call:
//			;// %r12        := table
//			;// %r13[15: 0] := id
//			;// %r13[31:16] := skip
//			;// %r14        := param
//			;// %r15        := fn
//			ld.uh		%r4, %r13		;// %r4  := id   = (unsigned short)(id_skip >>  0) /* 0`65535 */
//			ld.w		%r5, %r13		;// %r5  := skip = (unsigned short)(id_skip >> 16) /* 0`65535 */
//			xsrl		%r5, 16
//			ld.uh		%r6, [%r12]+		;// %r6  := table_size = *table++
//	LOT_seek_and_call_LOOP:					;// for(;;) {
//			sub		%r6, 1			;//   %r6  := table_size--
//			jrlt		LOT_seek_and_call_DIE	;//   if(table_size < 0) { DIE() } /* f[^G[: I\̒ɁAw肳ꂽidI񂪁A(skip+1)ȏoȂB */
//			ld.uh		%r9, [%r12]+		;//   %r9  := column_id   = *table++
//			ld.uh		%r13, [%r12]+		;//   %r13 := column_size = *table++
//			cmp		%r9, %r4		;//   if((column_id == id)
//			jrne		3
//			 sub		%r5, 1			;//   && (--skip < 0)) { break }
//			 jrlt		LOT_seek_and_call_RET
//			sla		%r13, 2			;//   %r13 :=          column_size * 4
//			jp.d		LOT_seek_and_call_LOOP	;// }
//			add		%r12, %r13		;//   %r12 := table += column_size * 4	*delay*
//	LOT_seek_and_call_RET:
//			jp		%r15			;// return (*fn)(table, column_size, param)
//	");
//	static void __attribute__((noreturn,unused)) LOT_seek_and_call_DIE() { DIE(); /*ICfNXs*/ } /*asmubNQ*/
//	#endif/*PIECE*/
//	
//	/*--------------------------------------------------------------------------*/
//	
//	#ifndef PIECE
//	int LOT_draw_table(const unsigned short* table, int id_skip, int rndval) {
//		return LOT_seek_and_call(table, id_skip, rndval, LOT_draw_column);
//	}
//	#else /*PIECE*/
//	int LOT_draw_table(const unsigned short* table, int id_skip, int rndval);
//	asm("
//			.code
//			.align		1
//			.global		LOT_draw_table
//	LOT_draw_table:
//			xld.w		%r15, LOT_draw_column
//			jp		LOT_seek_and_call
//	");
//	#endif/*PIECE*/
//	
//	/*--------------------------------------------------------------------------*/
//	
//	#ifndef PIECE
//	int LOT_get_table_weight(const unsigned short* table, int id_skip, int hitval_sel) {
//		return LOT_seek_and_call(table, id_skip, hitval_sel, LOT_get_column_weight);
//	}
//	#else /*PIECE*/
//	int LOT_get_table_weight(const unsigned short* table, int id_skip, int hitval_sel);
//	asm("
//			.code
//			.align		1
//			.global		LOT_get_table_weight
//	LOT_get_table_weight:
//			xld.w		%r15, LOT_get_column_weight
//			jp		LOT_seek_and_call
//	");
//	#endif/*PIECE*/
//	
//	/*--------------------------------------------------------------------------*/
//	
//	#ifndef PIECE
//	int LOT_get_table_column_id(const unsigned short* table, int i_column) {
//		int table_size, column_size, id, skip;
//		const unsigned short* column;
//		/* I\̗񐔂擾܂B */
//		table_size = *table++;
//		/* I\̗񐔂AȈ(0`)ȉłꍇ́AG[~܂B */
//		if(table_size <= i_column) { DIE(); }
//		/* (i_column)Ԗڂ̒ÍAid擾܂B */
//		column = table;
//		while(--i_column >= 0) {
//			               column++; /*column_id*/
//			column_size = *column++;
//			               column += column_size * 2/*{hitval,weight}*/;
//		}
//		id = *column;
//		/* (i_column)Ԗڂ̒IOɁA(i_column)Ԗڂ̒IƓid̒I񂪑݂ꍇA̗񐔂XLbv񐔂ƂĐ܂B */
//		skip = 0;
//		while(table != column) {
//			           if(*table++ == id) { skip += (1<<16); } /*column_id*/
//			column_size = *table++;
//			               table += column_size * 2/*{hitval,weight}*/;
//		}
//		/* IidƁAXLbv񐔂Ԃ܂B */
//		return id | skip;
//	}
//	#else /*PIECE*/
//	asm("
//			.code
//			.align		1
//			.global		LOT_get_table_column_id
//	LOT_get_table_column_id:
//			ld.uh		%r15, [%r12]+			;// %r15 := table_size = *table++;
//			cmp		%r15, %r13			;// if(table_size <= i_column) { DIE() }
//			jrle		LOT_get_table_column_id_DIE
//			ld.w		%r14, %r12			;// %r14 := column
//			;// %r12 := table	I[0]wĂ
//			;// %r13 := i_column
//			;// %r14 := column	I[0]wĂ
//	LOT_get_table_column_id_LOOP1:
//			sub		%r13, 1				;// while(--i_column >= 0) {
//			jrlt		LOT_get_table_column_id_EXIT1
//			add		%r14, 2				;//   %r14 :=                column++
//			ld.uh		%r15, [%r14]+			;//   %r15 := column_size = *column++
//			sla		%r15, 2				;//   %r15 :=                          (column_size * 4)
//			jp.d		LOT_get_table_column_id_LOOP1	;// }
//			add		%r14, %r15			;//   %r14 :=                column += (column_size * 4)	*delay*
//	LOT_get_table_column_id_EXIT1:
//			ld.uh		%r10, [%r14]			;// %r10 := id = *column
//			ld.w		%r11, 0				;// %r11 := skip = 0
//			;// %r10 := id		I[i_column]column_id
//			;// %r11 := skip
//			;// %r12 := table	I[0]wĂ
//			;// %r14 := column	I[i_column]wĂ
//	LOT_get_table_column_id_LOOP2:
//			cmp		%r12, %r14			;// while(table != column) {
//			jreq		LOT_get_table_column_id_EXIT2
//			ld.uh		%r13, [%r12]+			;//   %r13 := column_id   = *table++
//			ld.uh		%r15, [%r12]+			;//   %r15 := column_size = *table++
//			cmp		%r13, %r10			;//   if(column_id == id) {
//			jrne.d		LOT_get_table_column_id_SKIP
//			 sla		%r15, 2				;//   %r15 :=                         (column_size * 4)		*delay*
//			 xadd		%r11, %r11, 0x10000		;//     %r11 := skip += (1<<16)							u1ZŌ16rbgVtgorvu(1<<16)ZŌɂ̂܂orvꖽߐߖłBʓIȒI\łskip=0ł邱Ƃʂ邱Ƃ͏Ȃ̂Ő\ቺ͂قږł낤B
//	LOT_get_table_column_id_SKIP:
//			jp.d		LOT_get_table_column_id_LOOP2	;// }
//			add		%r12, %r15			;//   %r12 :=                table += (column_size * 4)		*delay*
//	LOT_get_table_column_id_EXIT2:
//			ret.d						;// return  id | skip
//			or		%r10, %r11			;// %r10 := id | skip						*delay*
//	");
//	static void __attribute__((noreturn,unused)) LOT_get_table_column_id_DIE() { DIE(); }
//	#endif/*PIECE*/
//	
//	/****************************************************************************
//	 *	uO[vwb_tI\vɑ΂钊I
//	 ****************************************************************************/
//	
//	static int LOT_seek_and_call_g(const unsigned short* table_g, const int* vp, int param, int (*fn)(const unsigned short* column, int column_size, int param)) {
//		int i, num_grps, grp_cols, id_skip = 0;
//		/* O[v擾B */
//		num_grps = *table_g++;
//		for(;;) {
//			/* O[vCfNX,,Iid擾B */
//			i = *vp++;
//			/* O[vCfNX,,IidAn[t[hlł邱ƂmFB */
//			if((unsigned)i >= USHRT_MAX) { DIE(); }
//			/* O[v(=fNgO0)AB */				//i͒IidłB
//			if(--num_grps < 0) { break; }
//			/* O[v񐔂擾B */
//			grp_cols = *table_g++;
//			/* O[v񐔂0łȂƂƁAO[vCfNXO[v񐔖ł邱ƂmFB */	//i̓O[vCfNXłB
//			if((unsigned)i >= (unsigned)grp_cols) { DIE(); }
//			/* ʂ̃XLbv񐔂ɍ̃O[v񐔂悶āAO[vCfNXB */
//			id_skip = (id_skip * grp_cols) + i;
//			/* XLbv񐔂An[t[hlł邱ƂmFB */	//I[o[t[ƂȂ悤AŏIʂł͂ȂmFB
//			if((unsigned)id_skip >= USHRT_MAX) { DIE(); }
//		}
//		/* XLbv񐔂ʃn[t[hփVtgāAʃn[t[hɒIidi[B */
//		id_skip = (id_skip << 16) | i;
//		/* ψ̏I[A(-1)ł邱ƂmFB */
//		if(*vp != -1) { DIE(); }
//		/* XLbv񐔂ƒIid̑gpāA֐sB */
//		return (*fn)(table_g, id_skip, param);
//	}
//	
//	/*--------------------------------------------------------------------------*/
//	
//	int LOT_draw_table_gl(const unsigned short* table_g, int rndval, ...) {
//		int retval;
//		va_list ap;
//		va_start(ap, rndval);
//		retval = LOT_draw_table_ga(table_g, ap, rndval);
//		va_end(ap);
//		return retval;
//	}
//	int LOT_draw_table_ga(const unsigned short* table_g, va_list ap, int rndval) {
//		int vp[(7+1)/**/], i = 0;			//O[v7(I[܂8)LΏ[ƍlBsꍇ͑₹B
//		for(;;) {
//			if((vp[i] = va_arg(ap, int)) == -1) { break; }
//			if(++i >= ARRAY_SIZE(vp)) { DIE(); }	//Œ~ꍇAvp[]s,,ďoI[YĂB炭҂ł낤B
//		}
//		return LOT_draw_table_gv(table_g, vp, rndval);
//	}
//	int LOT_draw_table_gv(const unsigned short* table_g, const int* vp, int rndval) {
//		return LOT_seek_and_call_g(table_g, vp, rndval, LOT_draw_table);
//	}
//	
//	/*--------------------------------------------------------------------------*/
//	
//	int LOT_get_table_weight_gl(const unsigned short* table_g, int hitval_sel, ...) {
//		int retval;
//		va_list ap;
//		va_start(ap, hitval_sel);
//		retval = LOT_get_table_weight_ga(table_g, ap, hitval_sel);
//		va_end(ap);
//		return retval;
//	}
//	int LOT_get_table_weight_ga(const unsigned short* table_g, va_list ap, int hitval_sel) {
//		int vp[(7+1)/**/], i = 0;			//O[v7(I[܂8)LΏ[ƍlBsꍇ͑₹B
//		for(;;) {
//			if((vp[i] = va_arg(ap, int)) == -1) { break; }
//			if(++i >= ARRAY_SIZE(vp)) { DIE(); }	//Œ~ꍇAvp[]s,,ďoI[YĂB炭҂ł낤B
//		}
//		return LOT_get_table_weight_gv(table_g, vp, hitval_sel);
//	}
//	int LOT_get_table_weight_gv(const unsigned short* table_g, const int* vp, int hitval_sel) {
//		return LOT_seek_and_call_g(table_g, vp, hitval_sel, LOT_get_table_weight);
//	}
//	
//}}2014/08/25폜:uI\v`ύX̂߂ɁAÂR[h폜܂BÂR[h2014/08/24܂Ŗ薳삵Ă̂ŁAQlpƂăRg܂܎cĂ܂B

//{{2014/08/25ǉ:ȍ~́A2014/08/25uI\v`ύXɒǉAVR[hłB}}

/****************************************************************************
 *	uI\vɑ΂钊I
 ****************************************************************************/

#ifndef PIECE
static int LOT_seek_and_call(const unsigned short* table, const int* pid, int param, int (*fn)(const unsigned short* column, int column_size, int param)) {
	int table_size, id_size, column_size, n_id, diff;
	/* I\̗񐔂擾܂B */
	table_size = *table++;
	/* Iids擾܂B */
	id_size    = *table++;
	for(;;) {
		/* I\̍ŏI𒴂ĂAG[~܂B */
		if(--table_size < 0) { DIE(); }
		/* Iidr܂B */
		n_id = id_size;
		diff = 0;
		while(--n_id >= 0) { diff |= (*table++ - *pid++); }		//AvP[VĒIidsȂςꍇAŕsvƂȂB
		/* I̗vf擾܂B */
		column_size = *table++;
		/* w肳ꂽid̑gI񂪌A܂B */
		if(!diff) { break; }
		/* w肳ꂽid̑g̃|C^߂܂B */
		pid -= id_size;
		/* IXLbv܂B */
		table += column_size * 2/*{hitval,weight}*/;
	}
	/* w肳ꂽIid̑ǵAI[mF܂B */
	if(*pid != -1) { DIE(); }						//AvP[VĒIids𑽂ςꍇAŃG[~B
	/* ֐s܂B */
	return (*fn)(table, column_size, param);
}
#else /*PIECE*/
/*static*/ int LOT_seek_and_call(const unsigned short* table, const int* pid, int param, int (*fn)(const unsigned short* column, int column_size, int param));
asm("
		.code
		.align		1
LOT_seek_and_call:
		;//%r12 := table
		;//%r13 := pid
		;//%r14 := param
		;//%r15 := fn
		ld.uh		%r4, [%r12]+					;//%r4  := table_size = *table++
		ld.uh		%r5, [%r12]+					;//%r5  := id_size    = *table++
		sla		%r5, 2						;//%r5  := id_size * sizeof(int)
LOT_seek_and_call_L1:								;//for(;;) {
		;//%r4  := table_size
		;//%r5  := id_size * sizeof(int)
		;//%r12 := table
		;//%r13 := pid
		;//%r14 := param
		;//%r15 := fn
		sub		%r4, 1						;//%r4  := table_size--
		jrlt		LOT_seek_and_call_DIE				;//if(table_size < 0) { DIE() }
		ld.w		%r6, %r5					;//%r6  := n_id = id_size * sizeof(int)
		ld.w		%r7, 0						;//%r7  := diff = 0
LOT_seek_and_call_L2:								;//for(;;) {
		;//%r4  := table_size
		;//%r5  := id_size * sizeof(int)
		;//%r6  := n_id
		;//%r7  := diff
		;//%r12 := table
		;//%r13 := pid
		;//%r14 := param
		;//%r15 := fn
		sub		%r6, 4						;//%r6  := n_id -= sizeof(int)
		jrlt		LOT_seek_and_call_L3				;//if(n_id < 0) { break }
		ld.uh		%r10, [%r12]+					;//%r10 :=          id1       = *table++
		ld.w		%r11, [%r13]+					;//%r11 :=                id2 = *pid++
		sub		%r10, %r11					;//%r10 :=         (id1 - id2)
		jp.d		LOT_seek_and_call_L2				;//}
		or		%r7, %r10					;//%r7  := diff |= (id1 - id2)					*delay*
LOT_seek_and_call_L3:
		;//%r4  := table_size
		;//%r5  := id_size * sizeof(int)
		;//%r7  := diff
		;//%r12 := table
		;//%r13 := pid
		;//%r14 := param
		;//%r15 := fn
		ld.uh		%r6, [%r12]+					;//%r6  := column_size = *table++
		cmp		%r7, 0						;//if(!diff) { break }
		jreq		LOT_seek_and_call_L4
		sub		%r13, %r5					;//%r13 := pid -=   (    id_size *     sizeof(int)           )
		sla		%r6, 2						;//%r6  :=          (column_size * 2 * sizeof(unsigned short))
		jp.d		LOT_seek_and_call_L1				;//}
		add		%r12, %r6					;//%r12 := table += (column_size * 2 * sizeof(unsigned short))	*delay*
LOT_seek_and_call_L4:
		;//%r6  := column_size
		;//%r12 := table
		;//%r13 := pid
		;//%r14 := param
		;//%r15 := fn
		ld.w		%r4, [%r13]					;//%r4  := id2 = *pid
		ld.w		%r13, %r6					;//%r13 := column_size					*anti-interlock*
		cmp		%r4, -1						;//if(id2 != -1) { DIE() }		
		jrne		LOT_seek_and_call_DIE				;//					
;//		ld.w		%r13, %r6					;//%r13 := column_size		
		jp		%r15						;//return (*fn)(table, column_size, param)			(jp.d %rb͕s)
");
static void __attribute__((noreturn,unused/*asmubNQ*/)) LOT_seek_and_call_DIE() { DIE(); }
#endif/*PIECE*/

/*--------------------------------------------------------------------------*/

#ifndef PIECE
int LOT_draw_table_l(const unsigned short* table, int rndval, ...) {
	int retval;
	va_list ap;
	va_start(ap, rndval);
	retval = LOT_draw_table_a(table, ap, rndval);
	va_end(ap);
	return retval;
}
int LOT_draw_table_a(const unsigned short* table, va_list ap, int rndval) {
	int id[(7+1)/**/], i = 0;			//pAIids7ȉ(I[܂8ȉ)ƍlď[낤Bsꍇ͑₹B
	for(;;) {
		if((id[i] = va_arg(ap, int)) == -1) { break; }
		if(++i >= ARRAY_SIZE(id)) { DIE(); }	//Œ~ꍇ́Aid[]s,,ďoI[YĂB炭҂낤B
	}
	return LOT_draw_table_v(table, id, rndval);
}
int LOT_draw_table_v(const unsigned short* table, const int* pid, int rndval) {
	return LOT_seek_and_call(table, pid, rndval, LOT_draw_column);
}
#else /*PIECE*/
int LOT_draw_table_l(const unsigned short* table, int rndval, ...);
int LOT_draw_table_a(const unsigned short* table, va_list ap, int rndval);
int LOT_draw_table_v(const unsigned short* table, const int* pid, int rndval);
asm("
		.align		1
		.global		LOT_draw_table_l
		.global		LOT_draw_table_a
		.global		LOT_draw_table_v
LOT_draw_table_l:
		;//%r12    := table
		;//[%sp+0] := retp
		;//[%sp+4] := rndval
		;//[%sp+8] := ...
		xadd		%r13, %sp, 8					;//%r13 := ap = &...
		xld.w		%r14, [%sp+4]					;//%r14 := rndval
LOT_draw_table_a:		;//AZuvOł́A
LOT_draw_table_v:		;//̓̊֐͓łB
		;//%r12    := table
		;//%r13    := pid = ap
		;//%r14    := rndval
		xld.w		%r15, LOT_draw_column				;//%r15 := LOT_draw_column
		xjp		LOT_seek_and_call				;//return LOT_seek_and_call(table, pid, rndval, LOT_draw_column)
");
#endif/*PIECE*/

/*--------------------------------------------------------------------------*/

#ifndef PIECE
int LOT_get_table_weight_l(const unsigned short* table, int hitval_sel, ...) {
	int retval;
	va_list ap;
	va_start(ap, hitval_sel);
	retval = LOT_get_table_weight_a(table, ap, hitval_sel);
	va_end(ap);
	return retval;
}
int LOT_get_table_weight_a(const unsigned short* table, va_list ap, int hitval_sel) {
	int id[(7+1)/**/], i = 0;			//pAIids7ȉ(I[܂8ȉ)ƍlď[낤Bsꍇ͑₹B
	for(;;) {
		if((id[i] = va_arg(ap, int)) == -1) { break; }
		if(++i >= ARRAY_SIZE(id)) { DIE(); }	//Œ~ꍇ́Aid[]s,,ďoI[YĂB炭҂낤B
	}
	return LOT_get_table_weight_v(table, id, hitval_sel);
}
int LOT_get_table_weight_v(const unsigned short* table, const int* pid, int hitval_sel) {
	return LOT_seek_and_call(table, pid, hitval_sel, LOT_get_column_weight);
}
#else /*PIECE*/
int LOT_get_table_weight_l(const unsigned short* table, int hitval_sel, ...);
int LOT_get_table_weight_a(const unsigned short* table, va_list ap, int hitval_sel);
int LOT_get_table_weight_v(const unsigned short* table, const int* pid, int hitval_sel);
asm("
		.align		1
		.global		LOT_get_table_weight_l
		.global		LOT_get_table_weight_a
		.global		LOT_get_table_weight_v
LOT_get_table_weight_l:
		;//%r12    := table
		;//[%sp+0] := retp
		;//[%sp+4] := hitval_sel
		;//[%sp+8] := ...
		xadd		%r13, %sp, 8					;//%r13 := ap = &...
		xld.w		%r14, [%sp+4]					;//%r14 := hitval_sel
LOT_get_table_weight_a:		;//AZuvOł́A
LOT_get_table_weight_v:		;//̓̊֐͓łB
		;//%r12    := table
		;//%r13    := pid = ap
		;//%r14    := hitval_sel
		xld.w		%r15, LOT_get_column_weight			;//%r15 := LOT_get_column_weight
		xjp		LOT_seek_and_call				;//return LOT_seek_and_call(table, pid, hitval_sel, LOT_get_column_weight)
");
#endif/*PIECE*/

/*--------------------------------------------------------------------------*/

#ifndef PIECE
void LOT_get_table_column_id(const unsigned short* table, int i_column, int* pid) {
	int table_size, id_size, column_size;
	/* I\̗񐔂擾܂B */
	table_size = *table++;
	/* Iids擾܂B */
	id_size    = *table++;
	/* I\̗񐔂AȈ(0`)ȉłꍇ́AG[~܂B */
	if(table_size <= i_column) { DIE(); }
	/* (i_column)Ԗڂ̒ÍAid̑g̃|C^擾܂B */
	while(--i_column >= 0) {
		table += id_size;
		column_size = *table++;
		table += column_size * 2/*{hitval,weight}*/;
	}
	/* id̑gi[܂B */
	while(--id_size >= 0) { *pid++ = *table++; }
	*pid++ = -1/*I[*/;
}
#else /*PIECE*/
void LOT_get_table_column_id(const unsigned short* table, int i_column, int* pid);
asm("
		.code
		.align		1
		.global		LOT_get_table_column_id
LOT_get_table_column_id:
		;//%r12 := table
		;//%r13 := i_column
		;//%r14 := pid
		ld.uh		%r4, [%r12]+					;//%r4  := table_size = *table++
		ld.uh		%r5, [%r12]+					;//%r5  := id_size    = *table++
		cmp		%r4, %r13					;//if(table_size <= i_column) { DIE() }
		jrle		LOT_get_table_column_id_DIE
		sla		%r5, 1						;//%r5  := id_size * sizeof(unsigned short)
LOT_get_table_column_id_L1:							;//for(;;) {
		;//%r5  := id_size * sizeof(unsigned short)
		;//%r12 := table
		;//%r13 := i_column
		;//%r14 := pid
		sub		%r13, 1						;//%r13 := i_column--
		jrlt		LOT_get_table_column_id_L2			;//if(i_column < 0) { break }
		add		%r12, %r5					;//%r12 := table += (    id_size     * sizeof(unsigned short))
		ld.uh		%r6, [%r12]+					;//%r6  :=           column_size = *table++
		sla		%r6, 2						;//%r6  :=          (column_size * 2 * sizeof(unsigned short))
		jp.d		LOT_get_table_column_id_L1			;//}
		add		%r12, %r6					;//%r12 := table += (column_size * 2 * sizeof(unsigned short))	*delay*
LOT_get_table_column_id_L2:							;//for(;;) {
		;//%r5  := id_size * sizeof(unsigned short)
		;//%r12 := table
		;//%r14 := pid
		sub		%r5, 2						;//%r5  := (id_size * sizeof(unsigned short)) -= sizeof(unsigned short)
		jrlt		LOT_get_table_column_id_L3			;//     if((id_size * sizeof(unsigned short)) < 0) { break }
		ld.uh		%r4, [%r12]+					;//%r4  :=  id = *table++
		ld.w		[%r14]+, %r4					;//*pid++ = id
		jp		LOT_get_table_column_id_L2			;//}
LOT_get_table_column_id_L3:
		ld.w		%r4, -1						;//%r4  :=  id = -1
		ld.w		[%r14], %r4					;//*pid   = id
		ret
");
static void __attribute__((noreturn,unused/*asmubNQ*/)) LOT_get_table_column_id_DIE() { DIE(); }
#endif/*PIECE*/
